/*
 * @OSF_COPYRIGHT@
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993, 1994, 1996 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (DCE).  See the file named COPYRIGHT.DCE for
 * the full copyright text.
 * All Rights Reserved
 */
/*
 * HISTORY
 * $Log: rsa_root_key.cxx,v $
 * Revision 1.1.2.1  1996/11/13  20:34:52  arvind
 * 	OSF DCE 1.2.2 Drop 5
 * 	[1996/11/13  20:15:48  arvind]
 *
 * Revision /main/DCE_1.2.2/1  1996/11/04  22:26 UTC  arvind
 * 	Cert-API drop 2 from DEC
 * 	[1996/11/03  23:24 UTC  arvind  /main/arvind_capi2/1]
 * 
 * $EndLog$
 */
/*
 * @DEC_COPYRIGHT@
 * Copyright (c) 1996
 * Digital Equipment Corporation, Maynard, Massachusetts, USA
 * All Rights Reserved
 *
 * This software is furnished under a license and may be used and copied
 * only  in  accordance  with  the  terms  of such  license and with the
 * inclusion of the above copyright notice.  This software or any  other
 * copies thereof may not be provided or otherwise made available to any
 * other person.  No title to and ownership of the  software  is  hereby
 * transferred.
 *
 * The information in this software  is subject to change without notice
 * and  should  not be  construed  as a commitment by Digitial Equipment
 * Corporation.
 *
 * Digital assumes no responsibility for the use or  reliablity  of its
 * software on equipment which is not supplied by Digital.
 *
 * FACILITY:    Certification API
 *
 * ABSTRACT:    RSA Data Security Inc. root key values
 *
 *
 * ENVIRONMENT: portable
 *
 * AUTHOR:
 *              John Wray
 *              Distributed Processing Engineering (DPE)
 *
 * DATE:        October 1996
 *
 */
#include <pkc_consts.h>

const static unsigned char RSA_LOW_ASSURANCE_ROOT_KEY_VALUE[] = {
  0x30, 0x7c, 0x30, 0x0d, 0x06, 0x09, 0x2a, 0x86, 0x48, 0x86, 0xf7, 0x0d,
  0x01, 0x01, 0x01, 0x05, 0x00, 0x03, 0x6b, 0x00, 0x30, 0x68, 0x02, 0x61,
  0x00, 0xb0, 0xb4, 0x0e, 0x9a, 0x3a, 0x46, 0x4e, 0x87, 0x03, 0xff, 0xb8,
  0xdb, 0xca, 0xd8, 0xaf, 0x41, 0xf3, 0xc3, 0xf4, 0x13, 0x1c, 0xf6, 0x57,
  0x1e, 0x39, 0xa5, 0x35, 0x49, 0xb4, 0x20, 0x94, 0xdc, 0x92, 0xf8, 0xee,
  0x1e, 0xa1, 0x03, 0x5f, 0x94, 0x21, 0x2b, 0x75, 0x1a, 0x3b, 0x07, 0x44,
  0x5d, 0xbd, 0xd6, 0xef, 0x4d, 0x7e, 0x23, 0x00, 0xf4, 0x2c, 0xf5, 0x73,
  0x47, 0x90, 0xbc, 0xe8, 0xba, 0x51, 0x7f, 0xa8, 0x19, 0xee, 0xf7, 0x5f,
  0x17, 0x46, 0xdc, 0xe5, 0xff, 0xd1, 0x23, 0xfe, 0x64, 0x2e, 0x68, 0x94,
  0xb3, 0x81, 0xde, 0x5a, 0x40, 0x28, 0x8d, 0xd6, 0xd7, 0x14, 0xaf, 0x84,
  0xef, 0x02, 0x03, 0x01, 0x00, 0x01
};


const unsigned char * RSA_LOW_ASSURANCE_ROOT_KEY =
                                        RSA_LOW_ASSURANCE_ROOT_KEY_VALUE;

const size_t RSA_LOW_ASSURANCE_ROOT_KEY_LENGTH =
                                      sizeof(RSA_LOW_ASSURANCE_ROOT_KEY_VALUE);


const static unsigned char RSA_LOW_ASSURANCE_ROOT_NAME_BER[97] = {
  0x30, 0x5f, 0x31, 0x0b, 0x30, 0x09, 0x06, 0x03, 0x55, 0x04, 0x06, 0x13,
  0x02, 0x55, 0x53, 0x31, 0x20, 0x30, 0x1e, 0x06, 0x03, 0x55, 0x04, 0x0a,
  0x13, 0x17, 0x52, 0x53, 0x41, 0x20, 0x44, 0x61, 0x74, 0x61, 0x20, 0x53,
  0x65, 0x63, 0x75, 0x72, 0x69, 0x74, 0x79, 0x2c, 0x20, 0x49, 0x6e, 0x63,
  0x2e, 0x31, 0x2e, 0x30, 0x2c, 0x06, 0x03, 0x55, 0x04, 0x0b, 0x13, 0x25,
  0x4c, 0x6f, 0x77, 0x20, 0x41, 0x73, 0x73, 0x75, 0x72, 0x61, 0x6e, 0x63,
  0x65, 0x20, 0x43, 0x65, 0x72, 0x74, 0x69, 0x66, 0x69, 0x63, 0x61, 0x74,
  0x69, 0x6f, 0x6e, 0x20, 0x41, 0x75, 0x74, 0x68, 0x6f, 0x72, 0x69, 0x74,
  0x79
};

const char RSA_LOW_ASSURANCE_ROOT_NAME[] =
                  "/c=US"
		  "/o=\"RSA Data Security, Inc.\""
		  "/ou=Low Assurance Certification Authority";

