/*
 * @OSF_COPYRIGHT@
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993, 1994, 1996 Open Software Foundation, Inc
 * ALL RIGHTS RESERVED (DCE).  See the file named COPYRIGHT.DCE for
 * the full copyright text.
 * All Rights Reserved
 */
/*
 * HISTORY
 * $Log: pkc_codesets.h,v $
 * Revision 1.1.2.1  1996/11/13  20:35:45  arvind
 * 	OSF DCE 1.2.2 Drop 5
 * 	[1996/11/13  19:53:25  arvind]
 *
 * Revision /main/DCE_1.2.2/1  1996/11/04  22:27 UTC  arvind
 * 	Cert-API drop 2 from DEC
 * 	[1996/11/03  23:23 UTC  arvind  /main/DCE_1.2.2/arvind_capi2/1]
 * 
 * $EndLog$
 */

#ifndef PKC_CODESETS_
#define PKC_CODESETS_

static char t61_to_local_array[256] = {
/* This array maps T61 characters to local 'C' characters.         */
/* Unsupported T61 characters are mapped to the C '?' character.   */
'\?',    /* 0/0 */
'\?',    /* 0/1 */
'\?',    /* 0/2 */
'\?',    /* 0/3 */
'\?',    /* 0/4 */
'\?',    /* 0/5 */
'\?',    /* 0/6 */
'\?',    /* 0/7 */
'\b',    /* 0/8 */
'\?',    /* 0/9 */
'\n',    /* 0/10 */
'\?',    /* 0/11 */
'\f',    /* 0/12 */
'\r',    /* 0/13 */
'\?',    /* 0/14 */
'\?',    /* 0/15 */

'\?',    /* 1/0 */
'\?',    /* 1/1 */
'\?',    /* 1/2 */
'\?',    /* 1/3 */
'\?',    /* 1/4 */
'\?',    /* 1/5 */
'\?',    /* 1/6 */
'\?',    /* 1/7 */
'\?',    /* 1/8 */
'\?',    /* 1/9 */
'\?',    /* 1/10 */
'\?',    /* 1/11 */
'\?',    /* 1/12 */
'\?',    /* 1/13 */
'\?',    /* 1/14 */
'\?',    /* 1/15 */

' ',    /* 2/0 */
'!',    /* 2/1 */
'\"',    /* 2/2 */
'#',    /* 2/3 */
'\xa8',    /* 2/4 */
'%',    /* 2/5 */
'&',    /* 2/6 */
'\'',    /* 2/7 */
'(',    /* 2/8 */
')',    /* 2/9 */
'*',    /* 2/10 */
'+',    /* 2/11 */
',',    /* 2/12 */
'-',    /* 2/13 */
'.',    /* 2/14 */
'/',    /* 2/15 */

'0',    /* 3/0 */
'1',    /* 3/1 */
'2',    /* 3/2 */
'3',    /* 3/3 */
'4',    /* 3/4 */
'5',    /* 3/5 */
'6',    /* 3/6 */
'7',    /* 3/7 */
'8',    /* 3/8 */
'9',    /* 3/9 */
':',    /* 3/10 */
';',    /* 3/11 */
'<',    /* 3/12 */
'=',    /* 3/13 */
'>',    /* 3/14 */
'\?',    /* 3/15 */

'@',    /* 4/0 */
'A',    /* 4/1 */
'B',    /* 4/2 */
'C',    /* 4/3 */
'D',    /* 4/4 */
'E',    /* 4/5 */
'F',    /* 4/6 */
'G',    /* 4/7 */
'H',    /* 4/8 */
'I',    /* 4/9 */
'J',    /* 4/10 */
'K',    /* 4/11 */
'L',    /* 4/12 */
'M',    /* 4/13 */
'N',    /* 4/14 */
'O',    /* 4/15 */

'P',    /* 5/0 */
'Q',    /* 5/1 */
'R',    /* 5/2 */
'S',    /* 5/3 */
'T',    /* 5/4 */
'U',    /* 5/5 */
'V',    /* 5/6 */
'W',    /* 5/7 */
'X',    /* 5/8 */
'Y',    /* 5/9 */
'Z',    /* 5/10 */
'[',    /* 5/11 */
' ',    /* 5/12 */
']',    /* 5/13 */
' ',    /* 5/14 */
'_',    /* 5/15 */

' ',    /* 6/0 */
'a',    /* 6/1 */
'b',    /* 6/2 */
'c',    /* 6/3 */
'd',    /* 6/4 */
'e',    /* 6/5 */
'f',    /* 6/6 */
'g',    /* 6/7 */
'h',    /* 6/8 */
'i',    /* 6/9 */
'j',    /* 6/10 */
'k',    /* 6/11 */
'l',    /* 6/12 */
'm',    /* 6/13 */
'n',    /* 6/14 */
'o',    /* 6/15 */

'p',    /* 7/0 */
'q',    /* 7/1 */
'r',    /* 7/2 */
's',    /* 7/3 */
't',    /* 7/4 */
'u',    /* 7/5 */
'v',    /* 7/6 */
'w',    /* 7/7 */
'x',    /* 7/8 */
'y',    /* 7/9 */
'z',    /* 7/10 */
' ',    /* 7/11 */
'|',    /* 7/12 */
'\?',    /* 7/13 */
'\?',    /* 7/14 */
'\?',    /* 7/15 */

'\?',    /* 8/0 */
'\?',    /* 8/1 */
'\?',    /* 8/2 */
'\?',    /* 8/3 */
'\?',    /* 8/4 */
'\?',    /* 8/5 */
'\?',    /* 8/6 */
'\?',    /* 8/7 */
'\?',    /* 8/8 */
'\?',    /* 8/9 */
'\?',    /* 8/10 */
'\?',    /* 8/11 */
'\?',    /* 8/12 */
'\?',    /* 8/13 */
'\?',    /* 8/14 */
'\?',    /* 8/15 */

'\?',    /* 9/0 */
'\?',    /* 9/1 */
'\?',    /* 9/2 */
'\?',    /* 9/3 */
'\?',    /* 9/4 */
'\?',    /* 9/5 */
'\?',    /* 9/6 */
'\?',    /* 9/7 */
'\?',    /* 9/8 */
'\?',    /* 9/9 */
'\?',    /* 9/10 */
'\?',    /* 9/11 */
'\?',    /* 9/12 */
'\?',    /* 9/13 */
'\?',    /* 9/14 */
'\?',    /* 9/15 */

'\?',    /* 10/0 */
'\xa1',    /* 10/1 */
'\xa2',    /* 10/2 */
'\xa3',    /* 10/3 */
'$',    /* 10/4 */
'\xa5',    /* 10/5 */
'#',    /* 10/6 */
'\xa7',    /* 10/7 */
'\xa8',    /* 10/8 */
'\?',    /* 10/9 */
'\?',    /* 10/10 */
'\xab',    /* 10/11 */
'\?',    /* 10/12 */
'\?',    /* 10/13 */
'\?',    /* 10/14 */
'\?',    /* 10/15 */

'\xb0',    /* 11/0 */
'\xb1',    /* 11/1 */
'\xb2',    /* 11/2 */
'\xb3',    /* 11/3 */
'\?',    /* 11/4 */
'\xb5',    /* 11/5 */
'\xb6',    /* 11/6 */
'\xb7',    /* 11/7 */
'\?',    /* 11/8 */
'\?',    /* 11/9 */
'\?',    /* 11/10 */
'\xbb',    /* 11/11 */
'\xbc',    /* 11/12 */
'\xbd',    /* 11/13 */
'\?',    /* 11/14 */
'\xbf',    /* 11/15 */

'\?',    /* 12/0 */
'\?',    /* 12/1 */
'\?',    /* 12/2 */
'\?',    /* 12/3 */
'\?',    /* 12/4 */
'\?',    /* 12/5 */
'\?',    /* 12/6 */
'\?',    /* 12/7 */
'\?',    /* 12/8 */
'\?',    /* 12/9 */
'\?',    /* 12/10 */
'\?',    /* 12/11 */
'\?',    /* 12/12 */
'\?',    /* 12/13 */
'\?',    /* 12/14 */
'\?',    /* 12/15 */

'\?',    /* 13/0 */
'\?',    /* 13/1 */
'\?',    /* 13/2 */
'\?',    /* 13/3 */
'\?',    /* 13/4 */
'\?',    /* 13/5 */
'\?',    /* 13/6 */
'\?',    /* 13/7 */
'\?',    /* 13/8 */
'\?',    /* 13/9 */
'\?',    /* 13/10 */
'\?',    /* 13/11 */
'\?',    /* 13/12 */
'\?',    /* 13/13 */
'\?',    /* 13/14 */
'\?',    /* 13/15 */

'\?',    /* 14/0 */
'\xc6',    /* 14/1 */
'\?',    /* 14/2 */
'\?',    /* 14/3 */
'\?',    /* 14/4 */
'\?',    /* 14/5 */
'\?',    /* 14/6 */
'\?',    /* 14/7 */
'\?',    /* 14/8 */
'\?',    /* 14/9 */
'\xd7',    /* 14/10 */
'\?',    /* 14/11 */
'\?',    /* 14/12 */
'\?',    /* 14/13 */
'\?',    /* 14/14 */
'\?',    /* 14/15 */

'\?',    /* 15/0 */
'\?',    /* 15/1 */
'\?',    /* 15/2 */
'\?',    /* 15/3 */
'\?',    /* 15/4 */
'\?',    /* 15/5 */
'\?',    /* 15/6 */
'\?',    /* 15/7 */
'\?',    /* 15/8 */
'\?',    /* 15/9 */
'\?',    /* 15/10 */
'\?',    /* 15/11 */
'\?',    /* 15/12 */
'\?',    /* 15/13 */
'\?',    /* 15/14 */
'\?'     /* 15/15 */
};

static char ia5_to_local_array[256] = {
/* This array maps IA5 characters to local 'C' characters.         */
/* Unsupported IA5 characters are mapped to the C '?' character.   */
'\?',    /* 0/0 */
'\?',    /* 0/1 */
'\?',    /* 0/2 */
'\?',    /* 0/3 */
'\?',    /* 0/4 */
'\?',    /* 0/5 */
'\?',    /* 0/6 */
'\a',    /* 0/7 */
'\b',    /* 0/8 */
'\?',    /* 0/9 */
'\n',    /* 0/10 */
'\?',    /* 0/11 */
'\f',    /* 0/12 */
'\r',    /* 0/13 */
'\?',    /* 0/14 */
'\?',    /* 0/15 */

'\?',    /* 1/0 */
'\?',    /* 1/1 */
'\?',    /* 1/2 */
'\?',    /* 1/3 */
'\?',    /* 1/4 */
'\?',    /* 1/5 */
'\?',    /* 1/6 */
'\?',    /* 1/7 */
'\?',    /* 1/8 */
'\?',    /* 1/9 */
'\?',    /* 1/10 */
'\?',    /* 1/11 */
'\?',    /* 1/12 */
'\?',    /* 1/13 */
'\?',    /* 1/14 */
'\?',    /* 1/15 */

' ',    /* 2/0 */
'!',    /* 2/1 */
'\"',    /* 2/2 */
'#',    /* 2/3 */
'$',    /* 2/4 */
'%',    /* 2/5 */
'&',    /* 2/6 */
'\'',    /* 2/7 */
'(',    /* 2/8 */
')',    /* 2/9 */
'*',    /* 2/10 */
'+',    /* 2/11 */
',',    /* 2/12 */
'-',    /* 2/13 */
'.',    /* 2/14 */
'/',    /* 2/15 */

'0',    /* 3/0 */
'1',    /* 3/1 */
'2',    /* 3/2 */
'3',    /* 3/3 */
'4',    /* 3/4 */
'5',    /* 3/5 */
'6',    /* 3/6 */
'7',    /* 3/7 */
'8',    /* 3/8 */
'9',    /* 3/9 */
':',    /* 3/10 */
';',    /* 3/11 */
'<',    /* 3/12 */
'=',    /* 3/13 */
'>',    /* 3/14 */
'\?',    /* 3/15 */

'@',    /* 4/0 */
'A',    /* 4/1 */
'B',    /* 4/2 */
'C',    /* 4/3 */
'D',    /* 4/4 */
'E',    /* 4/5 */
'F',    /* 4/6 */
'G',    /* 4/7 */
'H',    /* 4/8 */
'I',    /* 4/9 */
'J',    /* 4/10 */
'K',    /* 4/11 */
'L',    /* 4/12 */
'M',    /* 4/13 */
'N',    /* 4/14 */
'O',    /* 4/15 */

'P',    /* 5/0 */
'Q',    /* 5/1 */
'R',    /* 5/2 */
'S',    /* 5/3 */
'T',    /* 5/4 */
'U',    /* 5/5 */
'V',    /* 5/6 */
'W',    /* 5/7 */
'X',    /* 5/8 */
'Y',    /* 5/9 */
'Z',    /* 5/10 */
'[',    /* 5/11 */
'\\',    /* 5/12 */
']',    /* 5/13 */
'^',    /* 5/14 */
'_',    /* 5/15 */

'`',    /* 6/0 */
'a',    /* 6/1 */
'b',    /* 6/2 */
'c',    /* 6/3 */
'd',    /* 6/4 */
'e',    /* 6/5 */
'f',    /* 6/6 */
'g',    /* 6/7 */
'h',    /* 6/8 */
'i',    /* 6/9 */
'j',    /* 6/10 */
'k',    /* 6/11 */
'l',    /* 6/12 */
'm',    /* 6/13 */
'n',    /* 6/14 */
'o',    /* 6/15 */

'p',    /* 7/0 */
'q',    /* 7/1 */
'r',    /* 7/2 */
's',    /* 7/3 */
't',    /* 7/4 */
'u',    /* 7/5 */
'v',    /* 7/6 */
'w',    /* 7/7 */
'x',    /* 7/8 */
'y',    /* 7/9 */
'z',    /* 7/10 */
'{',    /* 7/11 */
'|',    /* 7/12 */
'}',    /* 7/13 */
'~',    /* 7/14 */
'\?',    /* 7/15 */

'\?',    /* 8/0 */
'\?',    /* 8/1 */
'\?',    /* 8/2 */
'\?',    /* 8/3 */
'\?',    /* 8/4 */
'\?',    /* 8/5 */
'\?',    /* 8/6 */
'\?',    /* 8/7 */
'\?',    /* 8/8 */
'\?',    /* 8/9 */
'\?',    /* 8/10 */
'\?',    /* 8/11 */
'\?',    /* 8/12 */
'\?',    /* 8/13 */
'\?',    /* 8/14 */
'\?',    /* 8/15 */

'\?',    /* 9/0 */
'\?',    /* 9/1 */
'\?',    /* 9/2 */
'\?',    /* 9/3 */
'\?',    /* 9/4 */
'\?',    /* 9/5 */
'\?',    /* 9/6 */
'\?',    /* 9/7 */
'\?',    /* 9/8 */
'\?',    /* 9/9 */
'\?',    /* 9/10 */
'\?',    /* 9/11 */
'\?',    /* 9/12 */
'\?',    /* 9/13 */
'\?',    /* 9/14 */
'\?',    /* 9/15 */

'\?',    /* 10/0 */
'\?',    /* 10/1 */
'\?',    /* 10/2 */
'\?',    /* 10/3 */
'$',    /* 10/4 */
'\?',    /* 10/5 */
'#',    /* 10/6 */
'\?',    /* 10/7 */
'\?',    /* 10/8 */
'\?',    /* 10/9 */
'\?',    /* 10/10 */
'\?',    /* 10/11 */
'\?',    /* 10/12 */
'\?',    /* 10/13 */
'\?',    /* 10/14 */
'\?',    /* 10/15 */

'\?',    /* 11/0 */
'\?',    /* 11/1 */
'\?',    /* 11/2 */
'\?',    /* 11/3 */
'\?',    /* 11/4 */
'\?',    /* 11/5 */
'\?',    /* 11/6 */
'\?',    /* 11/7 */
'\?',    /* 11/8 */
'\?',    /* 11/9 */
'\?',    /* 11/10 */
'\?',    /* 11/11 */
'\?',    /* 11/12 */
'\?',    /* 11/13 */
'\?',    /* 11/14 */
'\?',    /* 11/15 */

'\?',    /* 12/0 */
'\?',    /* 12/1 */
'\?',    /* 12/2 */
'\?',    /* 12/3 */
'\?',    /* 12/4 */
'\?',    /* 12/5 */
'\?',    /* 12/6 */
'\?',    /* 12/7 */
'\?',    /* 12/8 */
'\?',    /* 12/9 */
'\?',    /* 12/10 */
'\?',    /* 12/11 */
'\?',    /* 12/12 */
'\?',    /* 12/13 */
'\?',    /* 12/14 */
'\?',    /* 12/15 */

'\?',    /* 13/0 */
'\?',    /* 13/1 */
'\?',    /* 13/2 */
'\?',    /* 13/3 */
'\?',    /* 13/4 */
'\?',    /* 13/5 */
'\?',    /* 13/6 */
'\?',    /* 13/7 */
'\?',    /* 13/8 */
'\?',    /* 13/9 */
'\?',    /* 13/10 */
'\?',    /* 13/11 */
'\?',    /* 13/12 */
'\?',    /* 13/13 */
'\?',    /* 13/14 */
'\?',    /* 13/15 */

'\?',    /* 14/0 */
'\?',    /* 14/1 */
'\?',    /* 14/2 */
'\?',    /* 14/3 */
'\?',    /* 14/4 */
'\?',    /* 14/5 */
'\?',    /* 14/6 */
'\?',    /* 14/7 */
'\?',    /* 14/8 */
'\?',    /* 14/9 */
'\?',    /* 14/10 */
'\?',    /* 14/11 */
'\?',    /* 14/12 */
'\?',    /* 14/13 */
'\?',    /* 14/14 */
'\?',    /* 14/15 */

'\?',    /* 15/0 */
'\?',    /* 15/1 */
'\?',    /* 15/2 */
'\?',    /* 15/3 */
'\?',    /* 15/4 */
'\?',    /* 15/5 */
'\?',    /* 15/6 */
'\?',    /* 15/7 */
'\?',    /* 15/8 */
'\?',    /* 15/9 */
'\?',    /* 15/10 */
'\?',    /* 15/11 */
'\?',    /* 15/12 */
'\?',    /* 15/13 */
'\?',    /* 15/14 */
'\?'     /* 15/15 */
};

static char iso646_to_local_array[256] = {
/* This array maps ISO646 characters to local 'C' characters.         */
/* Unsupported ISO646 characters are mapped to the C '?' character.   */
'\?',    /* 0/0 */
'\?',    /* 0/1 */
'\?',    /* 0/2 */
'\?',    /* 0/3 */
'\?',    /* 0/4 */
'\?',    /* 0/5 */
'\?',    /* 0/6 */
'\a',    /* 0/7 */
'\b',    /* 0/8 */
'\?',    /* 0/9 */
'\n',    /* 0/10 */
'\?',    /* 0/11 */
'\f',    /* 0/12 */
'\r',    /* 0/13 */
'\?',    /* 0/14 */
'\?',    /* 0/15 */

'\?',    /* 1/0 */
'\?',    /* 1/1 */
'\?',    /* 1/2 */
'\?',    /* 1/3 */
'\?',    /* 1/4 */
'\?',    /* 1/5 */
'\?',    /* 1/6 */
'\?',    /* 1/7 */
'\?',    /* 1/8 */
'\?',    /* 1/9 */
'\?',    /* 1/10 */
'\?',    /* 1/11 */
'\?',    /* 1/12 */
'\?',    /* 1/13 */
'\?',    /* 1/14 */
'\?',    /* 1/15 */

' ',    /* 2/0 */
'!',    /* 2/1 */
'\"',    /* 2/2 */
'#',    /* 2/3 */
'$',    /* 2/4 */
'%',    /* 2/5 */
'&',    /* 2/6 */
'\'',    /* 2/7 */
'(',    /* 2/8 */
')',    /* 2/9 */
'*',    /* 2/10 */
'+',    /* 2/11 */
',',    /* 2/12 */
'-',    /* 2/13 */
'.',    /* 2/14 */
'/',    /* 2/15 */

'0',    /* 3/0 */
'1',    /* 3/1 */
'2',    /* 3/2 */
'3',    /* 3/3 */
'4',    /* 3/4 */
'5',    /* 3/5 */
'6',    /* 3/6 */
'7',    /* 3/7 */
'8',    /* 3/8 */
'9',    /* 3/9 */
':',    /* 3/10 */
';',    /* 3/11 */
'<',    /* 3/12 */
'=',    /* 3/13 */
'>',    /* 3/14 */
'\?',    /* 3/15 */

'@',    /* 4/0 */
'A',    /* 4/1 */
'B',    /* 4/2 */
'C',    /* 4/3 */
'D',    /* 4/4 */
'E',    /* 4/5 */
'F',    /* 4/6 */
'G',    /* 4/7 */
'H',    /* 4/8 */
'I',    /* 4/9 */
'J',    /* 4/10 */
'K',    /* 4/11 */
'L',    /* 4/12 */
'M',    /* 4/13 */
'N',    /* 4/14 */
'O',    /* 4/15 */

'P',    /* 5/0 */
'Q',    /* 5/1 */
'R',    /* 5/2 */
'S',    /* 5/3 */
'T',    /* 5/4 */
'U',    /* 5/5 */
'V',    /* 5/6 */
'W',    /* 5/7 */
'X',    /* 5/8 */
'Y',    /* 5/9 */
'Z',    /* 5/10 */
'[',    /* 5/11 */
'\\',    /* 5/12 */
']',    /* 5/13 */
'^',    /* 5/14 */
'_',    /* 5/15 */

'`',    /* 6/0 */
'a',    /* 6/1 */
'b',    /* 6/2 */
'c',    /* 6/3 */
'd',    /* 6/4 */
'e',    /* 6/5 */
'f',    /* 6/6 */
'g',    /* 6/7 */
'h',    /* 6/8 */
'i',    /* 6/9 */
'j',    /* 6/10 */
'k',    /* 6/11 */
'l',    /* 6/12 */
'm',    /* 6/13 */
'n',    /* 6/14 */
'o',    /* 6/15 */

'p',    /* 7/0 */
'q',    /* 7/1 */
'r',    /* 7/2 */
's',    /* 7/3 */
't',    /* 7/4 */
'u',    /* 7/5 */
'v',    /* 7/6 */
'w',    /* 7/7 */
'x',    /* 7/8 */
'y',    /* 7/9 */
'z',    /* 7/10 */
'{',    /* 7/11 */
'|',    /* 7/12 */
'}',    /* 7/13 */
'~',    /* 7/14 */
'\?',    /* 7/15 */

'\?',    /* 8/0 */
'\?',    /* 8/1 */
'\?',    /* 8/2 */
'\?',    /* 8/3 */
'\?',    /* 8/4 */
'\?',    /* 8/5 */
'\?',    /* 8/6 */
'\?',    /* 8/7 */
'\?',    /* 8/8 */
'\?',    /* 8/9 */
'\?',    /* 8/10 */
'\?',    /* 8/11 */
'\?',    /* 8/12 */
'\?',    /* 8/13 */
'\?',    /* 8/14 */
'\?',    /* 8/15 */

'\?',    /* 9/0 */
'\?',    /* 9/1 */
'\?',    /* 9/2 */
'\?',    /* 9/3 */
'\?',    /* 9/4 */
'\?',    /* 9/5 */
'\?',    /* 9/6 */
'\?',    /* 9/7 */
'\?',    /* 9/8 */
'\?',    /* 9/9 */
'\?',    /* 9/10 */
'\?',    /* 9/11 */
'\?',    /* 9/12 */
'\?',    /* 9/13 */
'\?',    /* 9/14 */
'\?',    /* 9/15 */

'\?',    /* 10/0 */
'\?',    /* 10/1 */
'\?',    /* 10/2 */
'\?',    /* 10/3 */
'\?',    /* 10/4 */
'\?',    /* 10/5 */
'\?',    /* 10/6 */
'\?',    /* 10/7 */
'\?',    /* 10/8 */
'\?',    /* 10/9 */
'\?',    /* 10/10 */
'\?',    /* 10/11 */
'\?',    /* 10/12 */
'\?',    /* 10/13 */
'\?',    /* 10/14 */
'\?',    /* 10/15 */

'\?',    /* 11/0 */
'\?',    /* 11/1 */
'\?',    /* 11/2 */
'\?',    /* 11/3 */
'\?',    /* 11/4 */
'\?',    /* 11/5 */
'\?',    /* 11/6 */
'\?',    /* 11/7 */
'\?',    /* 11/8 */
'\?',    /* 11/9 */
'\?',    /* 11/10 */
'\?',    /* 11/11 */
'\?',    /* 11/12 */
'\?',    /* 11/13 */
'\?',    /* 11/14 */
'\?',    /* 11/15 */

'\?',    /* 12/0 */
'\?',    /* 12/1 */
'\?',    /* 12/2 */
'\?',    /* 12/3 */
'\?',    /* 12/4 */
'\?',    /* 12/5 */
'\?',    /* 12/6 */
'\?',    /* 12/7 */
'\?',    /* 12/8 */
'\?',    /* 12/9 */
'\?',    /* 12/10 */
'\?',    /* 12/11 */
'\?',    /* 12/12 */
'\?',    /* 12/13 */
'\?',    /* 12/14 */
'\?',    /* 12/15 */

'\?',    /* 13/0 */
'\?',    /* 13/1 */
'\?',    /* 13/2 */
'\?',    /* 13/3 */
'\?',    /* 13/4 */
'\?',    /* 13/5 */
'\?',    /* 13/6 */
'\?',    /* 13/7 */
'\?',    /* 13/8 */
'\?',    /* 13/9 */
'\?',    /* 13/10 */
'\?',    /* 13/11 */
'\?',    /* 13/12 */
'\?',    /* 13/13 */
'\?',    /* 13/14 */
'\?',    /* 13/15 */

'\?',    /* 14/0 */
'\?',    /* 14/1 */
'\?',    /* 14/2 */
'\?',    /* 14/3 */
'\?',    /* 14/4 */
'\?',    /* 14/5 */
'\?',    /* 14/6 */
'\?',    /* 14/7 */
'\?',    /* 14/8 */
'\?',    /* 14/9 */
'\?',    /* 14/10 */
'\?',    /* 14/11 */
'\?',    /* 14/12 */
'\?',    /* 14/13 */
'\?',    /* 14/14 */
'\?',    /* 14/15 */

'\?',    /* 15/0 */
'\?',    /* 15/1 */
'\?',    /* 15/2 */
'\?',    /* 15/3 */
'\?',    /* 15/4 */
'\?',    /* 15/5 */
'\?',    /* 15/6 */
'\?',    /* 15/7 */
'\?',    /* 15/8 */
'\?',    /* 15/9 */
'\?',    /* 15/10 */
'\?',    /* 15/11 */
'\?',    /* 15/12 */
'\?',    /* 15/13 */
'\?',    /* 15/14 */
'\?'     /* 15/15 */
};

static unsigned char local_to_t61_array[256] = {
/* This array maps local 'C' characters to T61 characters.         */
/* Unsupported 'C' characters are mapped to the T61 '?' character. */
0x3f,    /* 0/0 */
0x3f,    /* 0/1 */
0x3f,    /* 0/2 */
0x3f,    /* 0/3 */
0x3f,    /* 0/4 */
0x3f,    /* 0/5 */
0x3f,    /* 0/6 */
0x3f,    /* 0/7 */
0x08,    /* 0/8 */
0x3f,    /* 0/9 */
0x0a,    /* 0/10 */
0x3f,    /* 0/11 */
0x0c,    /* 0/12 */
0x0d,    /* 0/13 */
0x3f,    /* 0/14 */
0x3f,    /* 0/15 */

0x3f,    /* 1/0 */
0x3f,    /* 1/1 */
0x3f,    /* 1/2 */
0x3f,    /* 1/3 */
0x3f,    /* 1/4 */
0x3f,    /* 1/5 */
0x3f,    /* 1/6 */
0x3f,    /* 1/7 */
0x3f,    /* 1/8 */
0x3f,    /* 1/9 */
0x3f,    /* 1/10 */
0x3f,    /* 1/11 */
0x3f,    /* 1/12 */
0x3f,    /* 1/13 */
0x3f,    /* 1/14 */
0x3f,    /* 1/15 */

0x7b,    /* 2/0 */
0x21,    /* 2/1 */
0x22,    /* 2/2 */
0xa6,    /* 2/3 */
0xa4,    /* 2/4 */
0x25,    /* 2/5 */
0x26,    /* 2/6 */
0x27,    /* 2/7 */
0x28,    /* 2/8 */
0x29,    /* 2/9 */
0x2a,    /* 2/10 */
0x2b,    /* 2/11 */
0x2c,    /* 2/12 */
0x2d,    /* 2/13 */
0x2e,    /* 2/14 */
0x2f,    /* 2/15 */

0x30,    /* 3/0 */
0x31,    /* 3/1 */
0x32,    /* 3/2 */
0x33,    /* 3/3 */
0x34,    /* 3/4 */
0x35,    /* 3/5 */
0x36,    /* 3/6 */
0x37,    /* 3/7 */
0x38,    /* 3/8 */
0x39,    /* 3/9 */
0x3a,    /* 3/10 */
0x3b,    /* 3/11 */
0x3c,    /* 3/12 */
0x3d,    /* 3/13 */
0x3e,    /* 3/14 */
0x3f,    /* 3/15 */

0x40,    /* 4/0 */
0x41,    /* 4/1 */
0x42,    /* 4/2 */
0x43,    /* 4/3 */
0x44,    /* 4/4 */
0x45,    /* 4/5 */
0x46,    /* 4/6 */
0x47,    /* 4/7 */
0x48,    /* 4/8 */
0x49,    /* 4/9 */
0x4a,    /* 4/10 */
0x4b,    /* 4/11 */
0x4c,    /* 4/12 */
0x4d,    /* 4/13 */
0x4e,    /* 4/14 */
0x4f,    /* 4/15 */

0x50,    /* 5/0 */
0x51,    /* 5/1 */
0x52,    /* 5/2 */
0x53,    /* 5/3 */
0x54,    /* 5/4 */
0x55,    /* 5/5 */
0x56,    /* 5/6 */
0x57,    /* 5/7 */
0x58,    /* 5/8 */
0x59,    /* 5/9 */
0x5a,    /* 5/10 */
0x5b,    /* 5/11 */
0x3f,    /* 5/12 */
0x5d,    /* 5/13 */
0x3f,    /* 5/14 */
0x5f,    /* 5/15 */

0x3f,    /* 6/0 */
0x61,    /* 6/1 */
0x62,    /* 6/2 */
0x63,    /* 6/3 */
0x64,    /* 6/4 */
0x65,    /* 6/5 */
0x66,    /* 6/6 */
0x67,    /* 6/7 */
0x68,    /* 6/8 */
0x69,    /* 6/9 */
0x6a,    /* 6/10 */
0x6b,    /* 6/11 */
0x6c,    /* 6/12 */
0x6d,    /* 6/13 */
0x6e,    /* 6/14 */
0x6f,    /* 6/15 */

0x70,    /* 7/0 */
0x71,    /* 7/1 */
0x72,    /* 7/2 */
0x73,    /* 7/3 */
0x74,    /* 7/4 */
0x75,    /* 7/5 */
0x76,    /* 7/6 */
0x77,    /* 7/7 */
0x78,    /* 7/8 */
0x79,    /* 7/9 */
0x7a,    /* 7/10 */
0x3f,    /* 7/11 */
0x7c,    /* 7/12 */
0x3f,    /* 7/13 */
0x3f,    /* 7/14 */
0x3f,    /* 7/15 */

0x3f,    /* 8/0 */
0x3f,    /* 8/1 */
0x3f,    /* 8/2 */
0x3f,    /* 8/3 */
0x3f,    /* 8/4 */
0x3f,    /* 8/5 */
0x3f,    /* 8/6 */
0x3f,    /* 8/7 */
0x3f,    /* 8/8 */
0x3f,    /* 8/9 */
0x3f,    /* 8/10 */
0x3f,    /* 8/11 */
0x3f,    /* 8/12 */
0x3f,    /* 8/13 */
0x3f,    /* 8/14 */
0x3f,    /* 8/15 */

0x3f,    /* 9/0 */
0x3f,    /* 9/1 */
0x3f,    /* 9/2 */
0x3f,    /* 9/3 */
0x3f,    /* 9/4 */
0x3f,    /* 9/5 */
0x3f,    /* 9/6 */
0x3f,    /* 9/7 */
0x3f,    /* 9/8 */
0x3f,    /* 9/9 */
0x3f,    /* 9/10 */
0x3f,    /* 9/11 */
0x3f,    /* 9/12 */
0x3f,    /* 9/13 */
0x3f,    /* 9/14 */
0x3f,    /* 9/15 */

0x3f,    /* 10/0 */
0xa1,    /* 10/1 */
0xa2,    /* 10/2 */
0xa3,    /* 10/3 */
0x3f,    /* 10/4 */
0xa5,    /* 10/5 */
0x3f,    /* 10/6 */
0xa7,    /* 10/7 */
0xa8,    /* 10/8 */
0x3f,    /* 10/9 */
0x3f,    /* 10/10 */
0xab,    /* 10/11 */
0x3f,    /* 10/12 */
0x3f,    /* 10/13 */
0x3f,    /* 10/14 */
0x3f,    /* 10/15 */

0xb0,    /* 11/0 */
0xb1,    /* 11/1 */
0xb2,    /* 11/2 */
0xb3,    /* 11/3 */
0x3f,    /* 11/4 */
0xb5,    /* 11/5 */
0xb6,    /* 11/6 */
0xb7,    /* 11/7 */
0x3f,    /* 11/8 */
0x3f,    /* 11/9 */
0x3f,    /* 11/10 */
0xbb,    /* 11/11 */
0xbc,    /* 11/12 */
0xbd,    /* 11/13 */
0x3f,    /* 11/14 */
0xbf,    /* 11/15 */

0x3f,    /* 12/0 */
0x3f,    /* 12/1 */
0x3f,    /* 12/2 */
0x3f,    /* 12/3 */
0x3f,    /* 12/4 */
0x3f,    /* 12/5 */
0xe1,    /* 12/6 */
0x3f,    /* 12/7 */
0x3f,    /* 12/8 */
0x3f,    /* 12/9 */
0x3f,    /* 12/10 */
0x3f,    /* 12/11 */
0x3f,    /* 12/12 */
0x3f,    /* 12/13 */
0x3f,    /* 12/14 */
0x3f,    /* 12/15 */

0x3f,    /* 13/0 */
0x3f,    /* 13/1 */
0x3f,    /* 13/2 */
0x3f,    /* 13/3 */
0x3f,    /* 13/4 */
0x3f,    /* 13/5 */
0x3f,    /* 13/6 */
0xea,    /* 13/7 */
0x3f,    /* 13/8 */
0x3f,    /* 13/9 */
0x3f,    /* 13/10 */
0x3f,    /* 13/11 */
0x3f,    /* 13/12 */
0x3f,    /* 13/13 */
0x3f,    /* 13/14 */
0x3f,    /* 13/15 */

0x3f,    /* 14/0 */
0x3f,    /* 14/1 */
0x3f,    /* 14/2 */
0x3f,    /* 14/3 */
0x3f,    /* 14/4 */
0x3f,    /* 14/5 */
0x3f,    /* 14/6 */
0x3f,    /* 14/7 */
0x3f,    /* 14/8 */
0x3f,    /* 14/9 */
0x3f,    /* 14/10 */
0x3f,    /* 14/11 */
0x3f,    /* 14/12 */
0x3f,    /* 14/13 */
0x3f,    /* 14/14 */
0x3f,    /* 14/15 */

0x3f,    /* 15/0 */
0x3f,    /* 15/1 */
0x3f,    /* 15/2 */
0x3f,    /* 15/3 */
0x3f,    /* 15/4 */
0x3f,    /* 15/5 */
0x3f,    /* 15/6 */
0x3f,    /* 15/7 */
0x3f,    /* 15/8 */
0x3f,    /* 15/9 */
0x3f,    /* 15/10 */
0x3f,    /* 15/11 */
0x3f,    /* 15/12 */
0x3f,    /* 15/13 */
0x3f,    /* 15/14 */
0x3f     /* 15/15 */
};

static unsigned char local_to_ia5_array[256] = {
/* This array maps local 'C' characters to IA5 characters.         */
/* Unsupported 'C' characters are mapped to the IA5 '?' character. */
0x3f,    /* 0/0 */
0x3f,    /* 0/1 */
0x3f,    /* 0/2 */
0x3f,    /* 0/3 */
0x3f,    /* 0/4 */
0x3f,    /* 0/5 */
0x3f,    /* 0/6 */
0x07,    /* 0/7 */
0x08,    /* 0/8 */
0x3f,    /* 0/9 */
0x0a,    /* 0/10 */
0x3f,    /* 0/11 */
0x0c,    /* 0/12 */
0x0d,    /* 0/13 */
0x3f,    /* 0/14 */
0x3f,    /* 0/15 */

0x3f,    /* 1/0 */
0x3f,    /* 1/1 */
0x3f,    /* 1/2 */
0x3f,    /* 1/3 */
0x3f,    /* 1/4 */
0x3f,    /* 1/5 */
0x3f,    /* 1/6 */
0x3f,    /* 1/7 */
0x3f,    /* 1/8 */
0x3f,    /* 1/9 */
0x3f,    /* 1/10 */
0x3f,    /* 1/11 */
0x3f,    /* 1/12 */
0x3f,    /* 1/13 */
0x3f,    /* 1/14 */
0x3f,    /* 1/15 */

0x20,    /* 2/0 */
0x21,    /* 2/1 */
0x22,    /* 2/2 */
0xa6,    /* 2/3 */
0xa4,    /* 2/4 */
0x25,    /* 2/5 */
0x26,    /* 2/6 */
0x27,    /* 2/7 */
0x28,    /* 2/8 */
0x29,    /* 2/9 */
0x2a,    /* 2/10 */
0x2b,    /* 2/11 */
0x2c,    /* 2/12 */
0x2d,    /* 2/13 */
0x2e,    /* 2/14 */
0x2f,    /* 2/15 */

0x30,    /* 3/0 */
0x31,    /* 3/1 */
0x32,    /* 3/2 */
0x33,    /* 3/3 */
0x34,    /* 3/4 */
0x35,    /* 3/5 */
0x36,    /* 3/6 */
0x37,    /* 3/7 */
0x38,    /* 3/8 */
0x39,    /* 3/9 */
0x3a,    /* 3/10 */
0x3b,    /* 3/11 */
0x3c,    /* 3/12 */
0x3d,    /* 3/13 */
0x3e,    /* 3/14 */
0x3f,    /* 3/15 */

0x40,    /* 4/0 */
0x41,    /* 4/1 */
0x42,    /* 4/2 */
0x43,    /* 4/3 */
0x44,    /* 4/4 */
0x45,    /* 4/5 */
0x46,    /* 4/6 */
0x47,    /* 4/7 */
0x48,    /* 4/8 */
0x49,    /* 4/9 */
0x4a,    /* 4/10 */
0x4b,    /* 4/11 */
0x4c,    /* 4/12 */
0x4d,    /* 4/13 */
0x4e,    /* 4/14 */
0x4f,    /* 4/15 */

0x50,    /* 5/0 */
0x51,    /* 5/1 */
0x52,    /* 5/2 */
0x53,    /* 5/3 */
0x54,    /* 5/4 */
0x55,    /* 5/5 */
0x56,    /* 5/6 */
0x57,    /* 5/7 */
0x58,    /* 5/8 */
0x59,    /* 5/9 */
0x5a,    /* 5/10 */
0x5b,    /* 5/11 */
0x5c,    /* 5/12 */
0x5d,    /* 5/13 */
0x5e,    /* 5/14 */
0x5f,    /* 5/15 */

0x60,    /* 6/0 */
0x61,    /* 6/1 */
0x62,    /* 6/2 */
0x63,    /* 6/3 */
0x64,    /* 6/4 */
0x65,    /* 6/5 */
0x66,    /* 6/6 */
0x67,    /* 6/7 */
0x68,    /* 6/8 */
0x69,    /* 6/9 */
0x6a,    /* 6/10 */
0x6b,    /* 6/11 */
0x6c,    /* 6/12 */
0x6d,    /* 6/13 */
0x6e,    /* 6/14 */
0x6f,    /* 6/15 */

0x70,    /* 7/0 */
0x71,    /* 7/1 */
0x72,    /* 7/2 */
0x73,    /* 7/3 */
0x74,    /* 7/4 */
0x75,    /* 7/5 */
0x76,    /* 7/6 */
0x77,    /* 7/7 */
0x78,    /* 7/8 */
0x79,    /* 7/9 */
0x7a,    /* 7/10 */
0x7b,    /* 7/11 */
0x7c,    /* 7/12 */
0x7d,    /* 7/13 */
0x7e,    /* 7/14 */
0x3f,    /* 7/15 */

0x3f,    /* 8/0 */
0x3f,    /* 8/1 */
0x3f,    /* 8/2 */
0x3f,    /* 8/3 */
0x3f,    /* 8/4 */
0x3f,    /* 8/5 */
0x3f,    /* 8/6 */
0x3f,    /* 8/7 */
0x3f,    /* 8/8 */
0x3f,    /* 8/9 */
0x3f,    /* 8/10 */
0x3f,    /* 8/11 */
0x3f,    /* 8/12 */
0x3f,    /* 8/13 */
0x3f,    /* 8/14 */
0x3f,    /* 8/15 */

0x3f,    /* 9/0 */
0x3f,    /* 9/1 */
0x3f,    /* 9/2 */
0x3f,    /* 9/3 */
0x3f,    /* 9/4 */
0x3f,    /* 9/5 */
0x3f,    /* 9/6 */
0x3f,    /* 9/7 */
0x3f,    /* 9/8 */
0x3f,    /* 9/9 */
0x3f,    /* 9/10 */
0x3f,    /* 9/11 */
0x3f,    /* 9/12 */
0x3f,    /* 9/13 */
0x3f,    /* 9/14 */
0x3f,    /* 9/15 */

0x3f,    /* 10/0 */
0x3f,    /* 10/1 */
0x3f,    /* 10/2 */
0x3f,    /* 10/3 */
0x3f,    /* 10/4 */
0x3f,    /* 10/5 */
0x3f,    /* 10/6 */
0x3f,    /* 10/7 */
0x3f,    /* 10/8 */
0x3f,    /* 10/9 */
0x3f,    /* 10/10 */
0x3f,    /* 10/11 */
0x3f,    /* 10/12 */
0x3f,    /* 10/13 */
0x3f,    /* 10/14 */
0x3f,    /* 10/15 */

0x3f,    /* 11/0 */
0x3f,    /* 11/1 */
0x3f,    /* 11/2 */
0x3f,    /* 11/3 */
0x3f,    /* 11/4 */
0x3f,    /* 11/5 */
0x3f,    /* 11/6 */
0x3f,    /* 11/7 */
0x3f,    /* 11/8 */
0x3f,    /* 11/9 */
0x3f,    /* 11/10 */
0x3f,    /* 11/11 */
0x3f,    /* 11/12 */
0x3f,    /* 11/13 */
0x3f,    /* 11/14 */
0x3f,    /* 11/15 */

0x3f,    /* 12/0 */
0x3f,    /* 12/1 */
0x3f,    /* 12/2 */
0x3f,    /* 12/3 */
0x3f,    /* 12/4 */
0x3f,    /* 12/5 */
0x3f,    /* 12/6 */
0x3f,    /* 12/7 */
0x3f,    /* 12/8 */
0x3f,    /* 12/9 */
0x3f,    /* 12/10 */
0x3f,    /* 12/11 */
0x3f,    /* 12/12 */
0x3f,    /* 12/13 */
0x3f,    /* 12/14 */
0x3f,    /* 12/15 */

0x3f,    /* 13/0 */
0x3f,    /* 13/1 */
0x3f,    /* 13/2 */
0x3f,    /* 13/3 */
0x3f,    /* 13/4 */
0x3f,    /* 13/5 */
0x3f,    /* 13/6 */
0x3f,    /* 13/7 */
0x3f,    /* 13/8 */
0x3f,    /* 13/9 */
0x3f,    /* 13/10 */
0x3f,    /* 13/11 */
0x3f,    /* 13/12 */
0x3f,    /* 13/13 */
0x3f,    /* 13/14 */
0x3f,    /* 13/15 */

0x3f,    /* 14/0 */
0x3f,    /* 14/1 */
0x3f,    /* 14/2 */
0x3f,    /* 14/3 */
0x3f,    /* 14/4 */
0x3f,    /* 14/5 */
0x3f,    /* 14/6 */
0x3f,    /* 14/7 */
0x3f,    /* 14/8 */
0x3f,    /* 14/9 */
0x3f,    /* 14/10 */
0x3f,    /* 14/11 */
0x3f,    /* 14/12 */
0x3f,    /* 14/13 */
0x3f,    /* 14/14 */
0x3f,    /* 14/15 */

0x3f,    /* 15/0 */
0x3f,    /* 15/1 */
0x3f,    /* 15/2 */
0x3f,    /* 15/3 */
0x3f,    /* 15/4 */
0x3f,    /* 15/5 */
0x3f,    /* 15/6 */
0x3f,    /* 15/7 */
0x3f,    /* 15/8 */
0x3f,    /* 15/9 */
0x3f,    /* 15/10 */
0x3f,    /* 15/11 */
0x3f,    /* 15/12 */
0x3f,    /* 15/13 */
0x3f,    /* 15/14 */
0x3f     /* 15/15 */
};

static unsigned char local_to_iso646_array[256] = {
/* This array maps local 'C' characters to ISO646 characters.         */
/* Unsupported 'C' characters are mapped to the ISO646 '?' character. */
0x3f,    /* 0/0 */
0x3f,    /* 0/1 */
0x3f,    /* 0/2 */
0x3f,    /* 0/3 */
0x3f,    /* 0/4 */
0x3f,    /* 0/5 */
0x3f,    /* 0/6 */
0x07,    /* 0/7 */
0x08,    /* 0/8 */
0x3f,    /* 0/9 */
0x0a,    /* 0/10 */
0x3f,    /* 0/11 */
0x0c,    /* 0/12 */
0x0d,    /* 0/13 */
0x3f,    /* 0/14 */
0x3f,    /* 0/15 */

0x3f,    /* 1/0 */
0x3f,    /* 1/1 */
0x3f,    /* 1/2 */
0x3f,    /* 1/3 */
0x3f,    /* 1/4 */
0x3f,    /* 1/5 */
0x3f,    /* 1/6 */
0x3f,    /* 1/7 */
0x3f,    /* 1/8 */
0x3f,    /* 1/9 */
0x3f,    /* 1/10 */
0x3f,    /* 1/11 */
0x3f,    /* 1/12 */
0x3f,    /* 1/13 */
0x3f,    /* 1/14 */
0x3f,    /* 1/15 */

0x20,    /* 2/0 */
0x21,    /* 2/1 */
0x22,    /* 2/2 */
0x23,    /* 2/3 */
0x24,    /* 2/4 */
0x25,    /* 2/5 */
0x26,    /* 2/6 */
0x27,    /* 2/7 */
0x28,    /* 2/8 */
0x29,    /* 2/9 */
0x2a,    /* 2/10 */
0x2b,    /* 2/11 */
0x2c,    /* 2/12 */
0x2d,    /* 2/13 */
0x2e,    /* 2/14 */
0x2f,    /* 2/15 */

0x30,    /* 3/0 */
0x31,    /* 3/1 */
0x32,    /* 3/2 */
0x33,    /* 3/3 */
0x34,    /* 3/4 */
0x35,    /* 3/5 */
0x36,    /* 3/6 */
0x37,    /* 3/7 */
0x38,    /* 3/8 */
0x39,    /* 3/9 */
0x3a,    /* 3/10 */
0x3b,    /* 3/11 */
0x3c,    /* 3/12 */
0x3d,    /* 3/13 */
0x3e,    /* 3/14 */
0x3f,    /* 3/15 */

0x40,    /* 4/0 */
0x41,    /* 4/1 */
0x42,    /* 4/2 */
0x43,    /* 4/3 */
0x44,    /* 4/4 */
0x45,    /* 4/5 */
0x46,    /* 4/6 */
0x47,    /* 4/7 */
0x48,    /* 4/8 */
0x49,    /* 4/9 */
0x4a,    /* 4/10 */
0x4b,    /* 4/11 */
0x4c,    /* 4/12 */
0x4d,    /* 4/13 */
0x4e,    /* 4/14 */
0x4f,    /* 4/15 */

0x50,    /* 5/0 */
0x51,    /* 5/1 */
0x52,    /* 5/2 */
0x53,    /* 5/3 */
0x54,    /* 5/4 */
0x55,    /* 5/5 */
0x56,    /* 5/6 */
0x57,    /* 5/7 */
0x58,    /* 5/8 */
0x59,    /* 5/9 */
0x5a,    /* 5/10 */
0x5b,    /* 5/11 */
0x5c,    /* 5/12 */
0x5d,    /* 5/13 */
0x5e,    /* 5/14 */
0x5f,    /* 5/15 */

0x60,    /* 6/0 */
0x61,    /* 6/1 */
0x62,    /* 6/2 */
0x63,    /* 6/3 */
0x64,    /* 6/4 */
0x65,    /* 6/5 */
0x66,    /* 6/6 */
0x67,    /* 6/7 */
0x68,    /* 6/8 */
0x69,    /* 6/9 */
0x6a,    /* 6/10 */
0x6b,    /* 6/11 */
0x6c,    /* 6/12 */
0x6d,    /* 6/13 */
0x6e,    /* 6/14 */
0x6f,    /* 6/15 */

0x70,    /* 7/0 */
0x71,    /* 7/1 */
0x72,    /* 7/2 */
0x73,    /* 7/3 */
0x74,    /* 7/4 */
0x75,    /* 7/5 */
0x76,    /* 7/6 */
0x77,    /* 7/7 */
0x78,    /* 7/8 */
0x79,    /* 7/9 */
0x7a,    /* 7/10 */
0x7b,    /* 7/11 */
0x7c,    /* 7/12 */
0x7d,    /* 7/13 */
0x7e,    /* 7/14 */
0x3f,    /* 7/15 */

0x3f,    /* 8/0 */
0x3f,    /* 8/1 */
0x3f,    /* 8/2 */
0x3f,    /* 8/3 */
0x3f,    /* 8/4 */
0x3f,    /* 8/5 */
0x3f,    /* 8/6 */
0x3f,    /* 8/7 */
0x3f,    /* 8/8 */
0x3f,    /* 8/9 */
0x3f,    /* 8/10 */
0x3f,    /* 8/11 */
0x3f,    /* 8/12 */
0x3f,    /* 8/13 */
0x3f,    /* 8/14 */
0x3f,    /* 8/15 */

0x3f,    /* 9/0 */
0x3f,    /* 9/1 */
0x3f,    /* 9/2 */
0x3f,    /* 9/3 */
0x3f,    /* 9/4 */
0x3f,    /* 9/5 */
0x3f,    /* 9/6 */
0x3f,    /* 9/7 */
0x3f,    /* 9/8 */
0x3f,    /* 9/9 */
0x3f,    /* 9/10 */
0x3f,    /* 9/11 */
0x3f,    /* 9/12 */
0x3f,    /* 9/13 */
0x3f,    /* 9/14 */
0x3f,    /* 9/15 */

0x3f,    /* 10/0 */
0x3f,    /* 10/1 */
0x3f,    /* 10/2 */
0x3f,    /* 10/3 */
0x3f,    /* 10/4 */
0x3f,    /* 10/5 */
0x3f,    /* 10/6 */
0x3f,    /* 10/7 */
0x3f,    /* 10/8 */
0x3f,    /* 10/9 */
0x3f,    /* 10/10 */
0x3f,    /* 10/11 */
0x3f,    /* 10/12 */
0x3f,    /* 10/13 */
0x3f,    /* 10/14 */
0x3f,    /* 10/15 */

0x3f,    /* 11/0 */
0x3f,    /* 11/1 */
0x3f,    /* 11/2 */
0x3f,    /* 11/3 */
0x3f,    /* 11/4 */
0x3f,    /* 11/5 */
0x3f,    /* 11/6 */
0x3f,    /* 11/7 */
0x3f,    /* 11/8 */
0x3f,    /* 11/9 */
0x3f,    /* 11/10 */
0x3f,    /* 11/11 */
0x3f,    /* 11/12 */
0x3f,    /* 11/13 */
0x3f,    /* 11/14 */
0x3f,    /* 11/15 */

0x3f,    /* 12/0 */
0x3f,    /* 12/1 */
0x3f,    /* 12/2 */
0x3f,    /* 12/3 */
0x3f,    /* 12/4 */
0x3f,    /* 12/5 */
0x3f,    /* 12/6 */
0x3f,    /* 12/7 */
0x3f,    /* 12/8 */
0x3f,    /* 12/9 */
0x3f,    /* 12/10 */
0x3f,    /* 12/11 */
0x3f,    /* 12/12 */
0x3f,    /* 12/13 */
0x3f,    /* 12/14 */
0x3f,    /* 12/15 */

0x3f,    /* 13/0 */
0x3f,    /* 13/1 */
0x3f,    /* 13/2 */
0x3f,    /* 13/3 */
0x3f,    /* 13/4 */
0x3f,    /* 13/5 */
0x3f,    /* 13/6 */
0x3f,    /* 13/7 */
0x3f,    /* 13/8 */
0x3f,    /* 13/9 */
0x3f,    /* 13/10 */
0x3f,    /* 13/11 */
0x3f,    /* 13/12 */
0x3f,    /* 13/13 */
0x3f,    /* 13/14 */
0x3f,    /* 13/15 */

0x3f,    /* 14/0 */
0x3f,    /* 14/1 */
0x3f,    /* 14/2 */
0x3f,    /* 14/3 */
0x3f,    /* 14/4 */
0x3f,    /* 14/5 */
0x3f,    /* 14/6 */
0x3f,    /* 14/7 */
0x3f,    /* 14/8 */
0x3f,    /* 14/9 */
0x3f,    /* 14/10 */
0x3f,    /* 14/11 */
0x3f,    /* 14/12 */
0x3f,    /* 14/13 */
0x3f,    /* 14/14 */
0x3f,    /* 14/15 */

0x3f,    /* 15/0 */
0x3f,    /* 15/1 */
0x3f,    /* 15/2 */
0x3f,    /* 15/3 */
0x3f,    /* 15/4 */
0x3f,    /* 15/5 */
0x3f,    /* 15/6 */
0x3f,    /* 15/7 */
0x3f,    /* 15/8 */
0x3f,    /* 15/9 */
0x3f,    /* 15/10 */
0x3f,    /* 15/11 */
0x3f,    /* 15/12 */
0x3f,    /* 15/13 */
0x3f,    /* 15/14 */
0x3f     /* 15/15 */
};

char t61_to_local(unsigned char t61c) {
   if (t61c > 255) return '?';
   return t61_to_local_array[t61c];
}

char ia5_to_local(unsigned char ia5c) {
    if (ia5c > 255) return '?';
    return ia5_to_local_array[ia5c];
}

char iso646_to_local(unsigned char iso646c) {
    if (iso646c > 127) return '?';
    return iso646_to_local_array[iso646c];
}

unsigned char local_to_t61(char c) {
    int uc;
    if (c > 255) return 0x3f; // '?'
    uc = ((c >= 0) ? c : c + 256);
    return local_to_t61_array[uc];
}

unsigned char local_to_ia5(char c) {
    int uc;
    if (c > 255) return 0x3f;
    uc = ((c >= 0) ? c : c + 256);
    return local_to_ia5_array[uc];
}

unsigned char local_to_iso646(char c) {
    int uc;
    if (c > 255) return 0x3f;
    uc = ((c >= 0) ? c : c + 256);
    return local_to_iso646_array[uc];
}

#endif
